const
   farbaPozadia = 7;
   farbaTiena = 8;
   SpiceColor = 11;
   SandColor = 3;
   SandColor2 = 14;
   EgaC:array[0..15] of byte=(0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);

{$IFDEF IMG}
const VELKOST_OBR = 172 div 2;
type obrazok = array[1..VELKOST_OBR] of byte;
{$ENDIF}

var
   oknorozdiel, vypisxmedzera,
   oknox1, oknoy1, oknox2, oknoy2,
   infox1, infoy1, infox2, infoy2,
   tahyx1, tahyy1, tahyx2, tahyy2,
   polickosizex, polickosizey:integer;

   vyskaFontu:integer;
   Sand,Spice:Array[1..2000] of Byte;
   infax1,infay1,infax2,infay2:array[1..5] of integer;

{$IFDEF IMG}
   obrazky:array[1..pocetRoznychJednotiek,1..2] of obrazok;
{$ENDIF}

procedure okno(x1,y1,x2,y2:integer); forward;

procedure initOkna; {lokalna procedura}
begin
   oknorozdiel := 2;
   oknox1 := oknorozdiel;
   oknoy1 := oknorozdiel;
   oknox2 := 499;
   oknoy2 := GetMaxY - oknorozdiel;
   infox1 := oknox2 + oknorozdiel + 1;
   infoy1 := oknoy1;
   infox2 := GetMaxX - oknorozdiel;
   infoy2 := GetMaxY * 6 div 7;
   tahyx1 := infox1;
   tahyy1 := infoy2 + oknorozdiel + 1;
   tahyx2 := infox2;
   tahyy2 := GetMaxY - oknorozdiel;
   vypisxmedzera := 7;
   polickosizex := (oknox2-oknox1) div velkostMapy;
   polickosizey := (oknoy2-oknoy1) div velkostMapy;
end;
Procedure ZmenRGB(C,R,G,B:Byte);
Begin
   Port[$3c8]:=EgaC[C];
   Port[$3c9]:=R;
   Port[$3c9]:=G;
   Port[$3c9]:=B;
end;

procedure initGrafika(pocetHracov:integer);
var gd,gm:integer;
    i,x,y:integer;
{$IFDEF IMG}
    fil:file;
{$ENDIF}
begin
   DetectGraph(gd,gm);
{$IFDEF EGA}
   gd:=EGA; gm:=1;
{$ENDIF}
   Initgraph(gd,gm,'.');
   ZmenRGB(SandColor2,55,40,0);
   ZmenRGB(SandColor,63,50,0);
   ZmenRGB(SpiceColor,55,30,0);
   ZmenRGB(2,0,45,0);
   ZmenRGB(10,0,55,0);
   initOkna;
   For X:=1 to PolickoSizeX do
     For Y:=1 to PolickoSizeY do  IF Random(3)=0 then PutPixel(X,Y,SandColor)
       else PutPixel(X,Y,SandColor2);

   GetImage(1,1,polickosizeX,polickosizey   ,Sand);
   For X:=1 to PolickoSizeX do
     For Y:=1 to PolickoSizeY do  IF Random(3)=0 then PutPixel(X,Y,SandColor)
       else PutPixel(X,Y,SpiceColor);
   GetImage(1,1,polickosizeX,polickosizey   ,Spice);
   ClearDevice;
   initOkna;

{$IFDEF IMG}
   assign(fil,'proboj.dat');
   reset(fil,1);
   for i:=1 to pocetRoznychJednotiek do
   begin
      blockread(fil, obrazky[i,1], VELKOST_OBR); {bitmapa}
      blockread(fil, obrazky[i,2], VELKOST_OBR); {maska}
   end;
   close(fil);
{$ENDIF}

   setBkColor(farbaPozadia);
   okno(oknox1,oknoy1,oknox2,oknoy2);
   okno(tahyx1,tahyy1,tahyx2,tahyy2);
   for i:=1 to pocetHracov do
   begin
      infax1[i] := infox1;
      infay1[i] := infoy1 + (i-1) * ((infoy2-infoy1) div pocetHracov);
      infax2[i] := infox2;
      infay2[i] := infay1[i] + ((infoy2-infoy1) div pocetHracov) -
         oknorozdiel - 1;
      if (i = pocetHracov) then infay2[i] := infoy2;
      okno(infax1[i],infay1[i],infax2[i],infay2[i]);
   end;
   SetTextStyle(TriplexFont, HorizDir, 4);
   vyskaFontu := TextHeight('H') + 1; {akoze najvyssie pismeno}
end;

procedure closeGrafika;
begin
   CloseGraph;
end;

procedure okno(x1,y1,x2,y2:integer);
begin
   setcolor(15);
   line(x1,y1,x2-1,y1);       {hore}
   line(x1,y1+1,x1,y2-1);     {vlavo}
   setcolor(8);
   line(x1+1,y2,x2,y2);       {dole}
   line(x2,y1+1,x2,y2-1);     {vpravo}
end;

procedure scrollUp(x1,y1,x2,y2,kolko:integer);
var bitmap:pointer;
    i:integer;
begin
   getmem(bitmap,imagesize(x1,y1+kolko,x2,y2));
   getimage(x1,y1+kolko,x2,y2,bitmap^);
   putimage(x1,y1,bitmap^,normalput);
   freemem(bitmap,imagesize(x1,y1+kolko,x2,y2));
   SetFillStyle(1,farbaPozadia);
   bar(x1,y2-kolko+1,x2,y2);
end;

{procedure vypis(co:string; farba:byte);
var i,stlpec:integer;
begin
   SetTextJustify(LeftText,TopText);
   scrollUp(vypisx1+2,vypisy1+3,vypisx2-2,vypisy2-2,vyskaFontu);
   i:=1; stlpec:=vypisxmedzera; {zaciname kreslit na sedmicke}
{   while (i <= length(co)) do
   begin
      if (vypisx1+stlpec+TextWidth(co[i]) > vypisx2-vypisxmedzera) then
      begin {vytieklo by pismeno}
{         stlpec:=vypisxmedzera;
         while ((i <= length(co)) and (co[i] = ' ')) do inc(i);
         if (i <= length(co)) then
            scrollUp(vypisx1+2,vypisy1+3,vypisx2-2,vypisy2-2,vyskaFontu);
      end;
      if (i <= length(co)) then
      begin
         setcolor(farbaTiena);
         outtextxy(vypisx1+stlpec+1,vypisy2+1 - (3 * vyskaFontu div 2),co[i]);
         setcolor(farba);
         outtextxy(vypisx1+stlpec,vypisy2 - (3 * vyskaFontu div 2),co[i]);
         inc(stlpec,TextWidth(co[i]));
         inc(i);
      end;
   end;
end;}

procedure vypisMena;
var i:byte;
begin
   SetTextJustify(LeftText,TopText);
   SetFillStyle(1,farbaPozadia);
   for i:=1 to {POCET_HRACOV}4 do 
   begin
      while (TextWidth(hrac[i].meno) >= infax2[i]-infax1[i]-8) do
         hrac[i].meno := copy(hrac[i].meno,1,length(hrac[i].meno)-1);

      bar(infax1[i]+2,infay1[i]+2,infax2[i]-2,infay2[i]-2);
      setColor(farbaTiena);
      outtextxy(infax1[i] + vypisxmedzera+1,infay1[i] + 1, hrac[i].meno);
      setColor(hrac[i].farba);
      outtextxy(infax1[i] + vypisxmedzera,infay1[i], hrac[i].meno);
   end;
end;

procedure vypisBody(ktoc:integer);
var s:string;
begin
   SetTextJustify(RightText,TopText);
   SetFillStyle(1,farbaPozadia);
   bar(infax1[ktoc]+2,infay1[ktoc] + 4 + TextHeight('H'),
      infax2[ktoc]-2,infay2[ktoc]-2);

   str(hrac[ktoc].peniaze,s);
   setColor(farbaTiena);
   outtextxy(infax2[ktoc] - vypisxmedzera+1,
      infay1[ktoc] + 1 + TextHeight('H'), s);
   setColor(hrac[ktoc].farba);
   outtextxy(infax2[ktoc] - vypisxmedzera,
      infay1[ktoc] + TextHeight('H'), s);
end;

procedure vypisTahy(tah:integer);
var s:string;
begin
   SetTextJustify(CenterText,CenterText);
   SetFillStyle(1,farbaPozadia);
   bar(tahyx1+2,tahyy1+2,tahyx2-2,tahyy2-2);

   str(tah,s);
   setColor(farbaTiena);
   outtextxy(1+(tahyx1+tahyx2) div 2, 1+(tahyy1+tahyy2) div 2, s);
   setColor(arbiterFarba);
   outtextxy((tahyx1+tahyx2) div 2, (tahyy1+tahyy2) div 2, s);
end;

procedure kresliPolicko(x,y:byte);
var x1,y1:integer;
    policko:integer;
    farba1,farba2,farba3:byte;
    cast, dam:real;
    notdraw:boolean;
begin
   x1 := ((oknox1+oknox2) - (velkostMapy*polickosizex)) div 2;
   y1 := ((oknoy1+oknoy2) - (velkostMapy*polickosizey)) div 2;

   policko:=mapa[x,y];
   if (policko <> 0) then
   begin
      if (policko = korenie) then
      begin
      PutImage(x1+2+((x-1)*polickosizex),
         y1+2+((y-1)*polickosizey), Spice,NormalPut);
{         SetFillStyle(3,SpiceColor);
         bar(
            x1+2+((x-1)*polickosizex),
            y1+2+((y-1)*polickosizey),
            x1+(x*polickosizex)-1,
            y1+(y*polickosizey)-1
         );}
      end else begin
      policko := abs(policko);
      if (jednotky[policko].vlastnik > 0) then
      begin
         cast := jednotky[policko].stavba /
            typyJednotiek[jednotky[policko].typ].timeToBuild;
         dam := jednotky[policko].shields /
            typyJednotiek[jednotky[policko].typ].defence;
         farba1 := hrac[jednotky[policko].vlastnik].farba;
         farba2 := hrac[jednotky[policko].vlastnik].farba2;
         if (dam > cast) then begin notdraw:=true;
            dam := cast; farba3:=farba2; end
         else begin farba3 := red; notdraw:=false; end;
         SetFillStyle(1,farba2);
         bar(
            x1+3+((x-1)*polickosizex) + round(cast*(polickosizex-4)),
            y1+2+((y-1)*polickosizey),
            x1+(x*polickosizex)-1,
            y1+(y*polickosizey)-4
         );
         SetFillStyle(1,farba1);
         bar(
            x1+2+((x-1)*polickosizex),
            y1+2+((y-1)*polickosizey),
            x1+2+((x-1)*polickosizex) + round(cast*(polickosizex-3)),
            y1+(y*polickosizey)-4
         );
         if ((not notdraw) and (dam < 1)) then
         begin
            SetColor(0);
            line(x1+2+((x-1)*polickosizex),
               y1+(y*polickosizey)-4,
               x1+(x*polickosizex)-1,
               y1+(y*polickosizey)-4);
         end;
         SetFillStyle(1,farba3);
         bar(
            x1+3+((x-1)*polickosizex) + round(dam*(polickosizex-4)),
            y1+(y*polickosizey)-3,
            x1+(x*polickosizex)-1,
            y1+(y*polickosizey)-1
         );
         SetFillStyle(1,farba1);
         bar(
            x1+2+((x-1)*polickosizex),
            y1+(y*polickosizey)-3,
            x1+2+((x-1)*polickosizex) + round(dam*(polickosizex-3)),
            y1+(y*polickosizey)-1
         );
         {$IFDEF IMG}
         putimage(
            x1+2+((x-1)*polickosizex),
            y1+2+((y-1)*polickosizey),
            obrazky[jednotky[policko].typ,2], AndPut
         );
         putimage(
            x1+2+((x-1)*polickosizex),
            y1+2+((y-1)*polickosizey),
            obrazky[jednotky[policko].typ,1], OrPut
         );
         {$ENDIF}
      end else begin {sem by sa to nemalo nikdy dostat}

{         SetFillStyle(1,0);
         bar(
            x1+2+((x-1)*polickosizex),
            y1+2+((y-1)*polickosizey),
            x1+(x*polickosizex)-1,
            y1+(y*polickosizey)-1
         );
 }     end;
      end;
   end else begin
      PutImage(x1+2+((x-1)*polickosizex),
         y1+2+((y-1)*polickosizey), Sand,NormalPut);
{      SetFillStyle(1,SandColor);
      bar(
         x1+2+((x-1)*polickosizex),
         y1+2+((y-1)*polickosizey),
         x1+(x*polickosizex)-1,
         y1+(y*polickosizey)-1
      );}
   end
   {TEMP}
{   SetColor(15);
   outtextxy(
      x1+2+((x-1)*polickosizex),
      y1+2+((y-1)*polickosizey),
      'a');{
      chr(48+(jednotky[policko].shields div 10)));}
end;

procedure kresliIhrisko;
var i,j,x1,y1:integer;
begin
   x1 := ((oknox1+oknox2) - (velkostMapy*polickosizex)) div 2;
   y1 := ((oknoy1+oknoy2) - (velkostMapy*polickosizey)) div 2;
   for i:=1 to velkostMapy do
      for j:=1 to velkostMapy do
      begin
{         If (Mapa[i,j]>-10) and (Mapa[i,j]<0)  then  okno(
            x1+1+((i-1)*polickosizex),
            y1+1+((j-1)*polickosizey),
            x1+(i*polickosizex),
            y1+(j*polickosizey)
         );                 }
         kresliPolicko(i,j);
      end;
end;
