Unit Hrac5;

interface

   uses dat_typy;

   function inicializujSa(cisloHraca:byte):string;
   procedure tahaj(
      var jednotky:typeJednotky;
      pocetJednotiek:word;
      mapa:typeMapa;
      peniaze:longint
   );

implementation

const RANGE = 5;
      RANGE_NEPR = 3;
      MAX_POZICIA = 33;

   var mojeCislo:byte;
   map:array[1..velkostmapy,1..velkostmapy] of integer;
   nPartii, nVojak, nLauncher, nTank, nKombajn, nSpice, nZakladna, nUtocnik, Utocnik : integer;
   isenemy:boolean;
   nTah,nJednotiek,statX,statY:integer;
   bb, jurkoActive:BOOLEAN;
   fEnemy:array[1..5] of integer;
   const toBuild:array[1..16] of integer = (kombajn,kombajn,launcher,kombajn,kombajn,
                      launcher,launcher,kombajn,launcher,kombajn,
                      launcher,kombajn,kombajn,launcher,
                      launcher,kombajn);

   PozicieX:array[1..MAX_POZICIA] of integer = (1,32,1,32,13,14,15,19,20,21,12,16,18,22,12,17,22,12,22,12,22,12,22,13
   ,21,14,20,15,16,18,19,17,16);
   PozicieY:array[1..MAX_POZICIA] of integer = (1,32,32,1,10,10,10,10,10,10,11,11,11,11,12,12,12,13,13,14,14,15,15,
   16,16,17,17,18,18,18,18,19,16);

function vzdi(x1,y1,x2,y2:integer):integer;
begin
   vzdi := abs(x1 - x2) + abs(y1 - y2);
end;

function inicializujSa(cisloHraca:byte):string;
begin
   if nPartii > 0 then
   begin
     if fEnemy[4] + fEnemy[1] + fEnemy[2] + fEnemy[3] - fEnemy[mojeCislo] < fEnemy[mojeCislo] then
        nPartii := nPartii
     else
       inc(nPartii);
   end
   else
       inc(nPartii);
   mojeCislo := cisloHraca;
   if nPartii mod 2 = 1 then begin
     inicializujSa := 'Oknit';
     jurkoactive := false;
   end else
   begin
     inicializujSa := 'Okruj';
     jurkoactive := true;
   end;


   nTah := 0;
end;

procedure pomocne(var je:typejednotky;pj:word;var mapa:typeMapa);
var
  i,j:integer;
begin
  isenemy:=false; fillchar(map,sizeof(map),0);
  nLauncher := 0;
  nKombajn := 0;
  nTank := 0;
  nVojak := 0;
  nSpice := 0;
  nZakladna := 0;
  nJednotiek := 0;
  for i:=1 to pj do begin
    if je[i].vlastnik<>mojecislo then begin
{      vyznac(je[i].}
      isenemy:=true;
    end else begin
      inc(nJednotiek);
      if je[i].typ=vojak then inc(nVojak);
      if je[i].typ=kombajn then inc(nKombajn);
      if je[i].typ=launcher then inc(nLauncher);
      if je[i].typ=tank then inc(nTank);
      if je[i].typ=zakladna then inc(nZakladna);
    end;
  end;
  for i:=1 to VelkostMapy do
   for j:=1 to VelkostMapy do
    if Mapa[i,j] = korenie then
     nSpice := nSpice+1;

     nUtocnik := nLauncher;
     Utocnik := launcher;

     {Ohodnotenie superov}
     for i:= 1 to 5 do
       fEnemy[i] := 0;
     for i:= 1 to pj do
     begin
       case je[i].typ of
vojak:   Inc(fEnemy[je[i].vlastnik],4);
tank:    Inc(fEnemy[je[i].vlastnik],10);
launcher:Inc(fEnemy[je[i].vlastnik],16);
veza:    Inc(fEnemy[je[i].vlastnik],0);
      end;
     end;
end;

function IsUtocnik( typ:integer ):boolean;
begin
  if nSpice > 0 then
  begin
    if (typ = tank) or (typ = launcher) or (typ = vojak) then
      IsUtocnik := TRUE
    else
      IsUtocnik := FALSE;
  end
  else
  begin
    if (typ = tank) or (typ = launcher) or (typ = vojak) then
      IsUtocnik := TRUE
    else
      IsUtocnik := FALSE;
  end;
end;

procedure UtocAZnicHo(var jednotky:typeJednotky; pocetJednotiek,who:integer );
var i,j,k,minVzd,minK:integer;
begin
  for i:= 1 to pocetJednotiek do
  begin
    if jednotky[i].vlastnik = who then begin
      break;
    end;
  end;
  if jednotky[i].vlastnik <> who then
  begin
    exit;
  end;
  for j:= 1 to pocetJednotiek do
  begin
    if (jednotky[j].vlastnik <> mojeCislo) then
      continue;
    if (JurkoActive = false) and (jednotky[j].prikaz <> stoj) then
      continue;
    if not IsUtocnik(jednotky[j].typ) then continue;

    minVzd := 300;
    minK := -1;

    for k := 1 to pocetJednotiek do
    begin
      if (jednotky[k].vlastnik <> who) then
        continue;
      if vzd(jednotky[j].x,jednotky[j].y,jednotky[k].x,jednotky[k].y) < minVzd then begin
        minK := k;
        minVzd := vzd(jednotky[j].x,jednotky[j].y,jednotky[k].x,jednotky[k].y);
      end;
    end;
    jednotky[j].prikaz := utoc;
    jednotky[j].idCiela := minK;
  end;
end;

function JeNaKraji(x,y:integer):boolean;
begin
  if (x = 1) or (x = VelkostMapy) or (y = 0) or (y = VelkostMapy) then
    JeNaKraji := TRUE
  else
    JeNaKraji := FALSE;
end;

{ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff}


{najde najblizsie korenie pri bode x,y}
procedure najdi_korenie(var jednotky:typeJednotky;
   var mapa:typeMapa; x, y:integer; var outx, outy:integer);
var nasiel, skonci:boolean;
    i,j:integer;
    ri,r:integer;
function je_nepr(x, y:integer):boolean;
var index:integer;
begin
   if ((x >= 1) and (x <= velkostMapy) and
      (y >= 1) and (y <= velkostMapy)) then
   begin
      if (mapa[x,y] = korenie) then je_nepr := false
      else if (mapa[x,y] = 0) then je_nepr := false
      else begin
         index := abs(mapa[x,y]);
         if (jednotky[index].vlastnik <> mojeCislo) then
            je_nepr := isUtocnik(jednotky[index].typ)
         else je_nepr:=false;
      end;
   end else je_nepr := false;
end;
function je_tam_korenie(x, y:integer):boolean;
var ii,jj,pocetNepr:integer;
begin
   if ((x >= 1) and (x <= velkostMapy) and
      (y >= 1) and (y <= velkostMapy)) then
   begin
      if (mapa[x,y] = korenie) then
      begin
         pocetNepr:=0;
         for ii:=i-RANGE to i+RANGE do
            for jj:=j-RANGE to j+RANGE do
               if (vzdi(ii,jj,i,j) < RANGE) then inc(pocetNepr, ord(je_nepr(ii,jj)));
         je_tam_korenie := (pocetNepr < RANGE_NEPR);
      end else je_tam_korenie := false;
   end else je_tam_korenie := false;
end;
begin
   nasiel := false; skonci := false;
   if (nSpice > 0) and (not skonci) then
   begin
      i := x; j := y-1;
      r := 1; {"polomer"}
      while ((not nasiel) and (r <= 2*velkostMapy)) do
      begin
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); inc(i); inc(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); dec(i); inc(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); dec(i); dec(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); inc(i); dec(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         if (not nasiel) then begin dec(j); inc(r); end;
      end;
      if (r > 2*velkostMapy) then skonci := true;
   end;
   if (nasiel) then
   begin
      outx := i; outy := j;
   end else begin
      outx := x; outy := y; {sorry, no korenie found}
   end;
end;

procedure zniLocal(var jednotky:typeJednotky; var mapa:typeMapa; i:integer);
var korenieX, korenieY:integer;
begin

   jednotky[i].prikaz := chod;
   najdi_korenie(jednotky, mapa, jednotky[i].x, jednotky[i].y, korenieX, korenieY);
   jednotky[i].tx := korenieX;
   jednotky[i].ty := korenieY;

end;

{ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff}


procedure tahajJurko(var jednotky:typeJednotky;
   pocetJednotiek:word; var mapa:typeMapa; peniaze:longint);
var i,j:word;
    minEnemyId, minEnemyDistance, vzdd, kX, kY, iLauncher,iTAnk : word;
    statX, statY,PairCount : integer;
    PriblizX, PriblizY, fUtok:integer;
begin
   inc(nTah);
   iLauncher := 0;
   iTank := 0;
   pomocne(jednotky,pocetjednotiek,mapa);

   for i:=1 to pocetJednotiek do
   begin
     if jednotky[i].vlastnik = mojeCislo then
        jednotky[i].prikaz := stoj;
   end;

   for i:=1 to pocetJednotiek do
   begin
     if jednotky[i].vlastnik = mojeCislo then begin
       if (typyJednotiek[jednotky[i].typ].speed = 0) then begin
         {Zakladna}
         statX := jednotky[i].x;
         statY := jednotky[i].y;
         jednotky[i].prikaz := postav;
         jednotky[i].tx := jednotky[i].x;
         jednotky[i].ty := jednotky[i].y;
         if ((jednotky[i].x < velkostMapy) and (mapa[jednotky[i].x+1, jednotky[i].y] = 0)) then
            jednotky[i].tx := jednotky[i].x + 1
         else if ((jednotky[i].y < velkostMapy) and (mapa[jednotky[i].x, jednotky[i].y+1] = 0)) then
            jednotky[i].ty := jednotky[i].y + 1;

         if ((jednotky[i].x > 1) and (mapa[jednotky[i].x-1, jednotky[i].y] = 0)) then
            jednotky[i].tx := jednotky[i].x - 1
         else if ((jednotky[i].y > 1) and (mapa[jednotky[i].x, jednotky[i].y-1] = 0)) then
            jednotky[i].ty := jednotky[i].y - 1;

         if isenemy then begin
{             if ph<6 then jednotky[i].idCiela := kombajn else}
              if nKombajn < 10 then begin
                if nKombajn < 3 then begin
                  jednotky[i].idCiela := kombajn;
                end
                else
                  if nUtocnik < 4 then
                     jednotky[i].idCiela := Utocnik
                  else
                    if nZakladna < 6 then
                       jednotky[i].idCiela := zakladna
                    else
                      jednotky[i].idCiela := kombajn;

              end else begin
                if nZakladna < 8 then
                  jednotky[i].idCiela := zakladna
                else
                  jednotky[i].idCiela := Utocnik;
              end;
                  if(JeNakraji(jednotky[i].tx, jednotky[i].ty)) then begin
                    if (nZakladna < 8) and (nUtocnik > 6) then begin
                       jednotky[i].idCiela := zakladna;
                    end;
                  end;
         end else begin


             jednotky[i].prikaz:=stoj;


         end;

       end;
     end
     else
     begin


     end;
   end;

   {Harvestre}
   for i:= 1 to pocetJednotiek do
   begin
     if nUtocnik < 6 then continue;

     if jednotky[i].vlastnik <> mojeCislo then
     begin
       {Nie moja jednotka}
       if (jednotky[i].prikaz = zni) or (nTah > 500) then
       begin

       end;
     end;

   end;

   PairCount := 0;

   for i:=1 to pocetJednotiek do
   begin
     if jednotky[i].vlastnik = mojeCislo then
       if (jednotky[i].prikaz = stoj) or (jednotky[i].typ = kombajn) then
       begin
         if typyJednotiek[jednotky[i].typ].kapacita > 0 then
         begin
           if nSpice > 0 then
              zniLocal(jednotky, mapa, i)
{              jednotky[i].prikaz := zni}
           else
           begin
             jednotky[i].prikaz := chod;
             jednotky[i].tx := statX;
             jednotky[i].ty := (statY+velkostMapy div 2) div 2;
           end;
         end;
         if IsUtocnik(jednotky[i].typ) then
         begin
           inc(PairCount);
           if nUtocnik > 8 then
           begin
             PriblizX := nTah div 100;
             PriblizY := nTah div 100;
             if statY > 10 then PriblizY := -PriblizY;
             if statX > 10 then PriblizX := -PriblizX;

             if (PairCount mod 2) = 0 then
             begin
               jednotky[i].prikaz := chod;
               jednotky[i].tx := (2*(velkostMapy div 2) + 5*statX) div 7 + (PairCount mod 15) div 2;
               jednotky[i].ty := (3*(velkostMapy div 2) + statY) div 4 + PriblizY;
             end
             else
             begin
               jednotky[i].prikaz := chod;
               jednotky[i].tx := (3*(velkostMapy div 2) + statX) div 4 + PriblizX;
               jednotky[i].ty := (2*(velkostMapy div 2) + 5*statY) div 7  + (PairCount mod 10) div 2 ;
             end;
           end
           else begin
             jednotky[i].prikaz := chod;
             jednotky[i].tx := (velkostMapy div 2 + statX) div 2;
             jednotky[i].ty := (velkostMapy div 2 + statY) div 2 + (PairCount mod 10) div 2;
           end;
         end;
       end;
   end;

   for i:=1 to PocetJednotiek do begin
       if (jednotky[i].vlastnik = mojecislo) and (jednotky[i].typ = launcher) then
        for j:=1 to PocetJednotiek do begin
         if (jednotky[j].vlastnik <> mojecislo) and
         ((jednotky[j].typ = launcher) or
         (jednotky[j].typ = tank) or
         (jednotky[j].typ = vojak)) then begin
                          if vzd(jednotky[i].x, jednotky[i].y,
                             jednotky[j].x, jednotky[j].y) < 7 then begin
                                            jednotky[i].prikaz := utoc;
                                            jednotky[i].idCiela := j;
                             end;

         end;
        end;

   end;

   for i:= 1 to 4 do
   begin
    if i = mojeCislo then continue;
    if nTah < POCET_TAHOV div 2 then continue;

    if (fEnemy[1]+fEnemy[2]+fEnemy[3]+fEnemy[4]+100 < 2*fEnemy[MojeCislo]) and (fEnemy[MojeCislo]>50) then
      UtocAZnicHo(jednotky, pocetJednotiek, i);
   end;


end;



procedure tahajTinko(var jednotky:typeJednotky;
   pocetJednotiek:word; var mapa:typeMapa; peniaze:longint);
var i,j:integer;
    minEnemyId, minEnemyDistance, vzdd, kX, kY, iLauncher,iTAnk : integer;
    PairCount : integer;
    fUtok:integer;
begin
  inc(nTah);
   iLauncher := 0;
  iTank := 0;
   pomocne(jednotky,pocetjednotiek,mapa);

   for i:=1 to pocetJednotiek do
   begin
     if jednotky[i].vlastnik = mojeCislo then
        jednotky[i].prikaz := stoj;
   end;

   statX := 0;
   statY := 0;

   for i:=1 to pocetJednotiek do
   begin
     if jednotky[i].vlastnik = mojeCislo then begin
       if (typyJednotiek[jednotky[i].typ].speed = 0) then begin
         {Zakladna}
         statX := jednotky[i].x;
         statY := jednotky[i].y;
         jednotky[i].prikaz := postav;
         jednotky[i].tx := jednotky[i].x;
         jednotky[i].ty := jednotky[i].y;
         if ((jednotky[i].x < velkostMapy) and (mapa[jednotky[i].x+1, jednotky[i].y] = 0)) then
            jednotky[i].tx := jednotky[i].x + 1
         else if ((jednotky[i].y < velkostMapy) and (mapa[jednotky[i].x, jednotky[i].y+1] = 0)) then
            jednotky[i].ty := jednotky[i].y + 1;

         if ((jednotky[i].x > 1) and (mapa[jednotky[i].x-1, jednotky[i].y] = 0)) then
            jednotky[i].tx := jednotky[i].x - 1
         else if ((jednotky[i].y > 1) and (mapa[jednotky[i].x, jednotky[i].y-1] = 0)) then
            jednotky[i].ty := jednotky[i].y - 1;

         if isenemy then begin
{             if ph<6 then jednotky[i].idCiela := kombajn else}


            if nJednotiek <= 16 then
              jednotky[i].idCiela := toBuild[nJednotiek]
            else
              jednotky[i].idCiela := Utocnik;

            if (nUtocnik > 4) and (nKombajn < 5) then
              jednotky[i].idCiela := kombajn;

            if (nUtocnik > 8) and (nKombajn < 8) then
              jednotky[i].idCiela := kombajn;

            if (nUtocnik > 10) and (nKombajn < 11) then
              jednotky[i].idCiela := kombajn;


            if JeNaKraji(jednotky[i].tx,jednotky[i].ty) and (nJednotiek > 5) and (nZakladna < 7) then
              jednotky[i].idCiela := zakladna;
            if JeNaKraji(jednotky[i].tx,jednotky[i].ty) and (nJednotiek > 12) and (nZakladna < 9) then
              jednotky[i].idCiela := zakladna;
            if JeNaKraji(jednotky[i].tx,jednotky[i].ty) and (nJednotiek > 19) and (nZakladna < 12) then
              jednotky[i].idCiela := zakladna;
            if JeNaKraji(jednotky[i].tx,jednotky[i].ty) and (nJednotiek > 24) and (nZakladna < 16) then
              jednotky[i].idCiela := zakladna;

            inc(nJednotiek);
            {  if nKombajn < 10 then begin
                if nKombajn < 3 then begin
                  jednotky[i].idCiela := kombajn;
                end
                else
                  if nUtocnik < 4 then
                     jednotky[i].idCiela := Utocnik
                  else
                    if nZakladna < 5 then
                       jednotky[i].idCiela := zakladna
                    else
                      jednotky[i].idCiela := kombajn;
              end else begin
                if nZakladna < 8 then
                  jednotky[i].idCiela := zakladna
                else
                  jednotky[i].idCiela := Utocnik;
              end;}
{           end;}
         end else begin
{           if h<6 then jednotky[i].idciela:=kombajn else begin}
             jednotky[i].prikaz:=stoj;
{           end;}
         end;

       end;
     end
     else
     begin
       {Nie moja jednotka}
       if (jednotky[i].idCiela <= 0) then
         continue;
       if (jednotky[i].idCiela > pocetJednotiek) then
         continue;
       bb := FALSE;
       if (jednotky[jednotky[i].idCiela].vlastnik = mojeCislo) then bb := TRUE;
       if (vzd(statX,statY,jednotky[i].x,jednotky[i].y) < 12) then bb := TRUE;
       if bb then
       begin
         {Utoci na mna svina}
         if not IsUtocnik(jednotky[i].typ) then
           continue;
         if abs(statX-jednotky[i].x) > velkostMapy - 5 then
           continue;
         if abs(statY-jednotky[i].y) > velkostMapy - 5 then
           continue;

         fUtok := 100;
         for j:= 1 to pocetJednotiek do
         begin
           if (jednotky[j].vlastnik = mojeCislo) and (jednotky[j].prikaz = stoj) then
           begin
             if IsUtocnik(jednotky[j].typ) then
             begin
               if abs(jednotky[i].x-jednotky[j].x)+abs(jednotky[i].y-jednotky[j].y) < 20 then
               begin
                 fUtok := fUtok - 25;
                 jednotky[j].prikaz := utoc;
                 jednotky[j].idCiela := i;
               end;
             end;
             if fUtok <= 0 then
               break;
           end;
         end;
       end;
     end;
   end;

   {Harvestre}
   for i:= 1 to pocetJednotiek do
   begin
     if nUtocnik < 6 then continue;

     if jednotky[i].vlastnik <> mojeCislo then
     begin
       {Nie moja jednotka}
       if (jednotky[i].prikaz = zni) then
       begin
         {Harvester -- to hovado}
         if (abs(statX-jednotky[i].x) > velkostMapy - 13) then
           continue;
         if (abs(statY-jednotky[i].y) > velkostMapy - 13) then
           continue;

         fUtok := 100;
         for j:= 1 to pocetJednotiek do
         begin
           if (jednotky[j].vlastnik = mojeCislo) and (jednotky[j].prikaz = stoj) then
           begin
             if IsUtocnik(jednotky[j].typ) then
             begin
               if (abs(jednotky[i].x-jednotky[j].x)+abs(jednotky[i].y-jednotky[j].y) < 20) then
               begin
                 fUtok := fUtok - 25;
                 jednotky[j].prikaz := utoc;
                 jednotky[j].idCiela := i;
               end;
             end;
             if fUtok <= 0 then
               break;
           end;
         end;
       end;
     end;

   end;

   PairCount := 0;

   for i:= 1 to 4 do
   begin
    if i = mojeCislo then continue;
    if nTah < POCET_TAHOV div 2 then continue;

    if (fEnemy[1]+fEnemy[2]+fEnemy[3]+fEnemy[4]+100 < 2*fEnemy[MojeCislo]) and (fEnemy[MojeCislo]>50) then
      UtocAZnicHo(jednotky, pocetJednotiek, i);
   end;
{   for i:= 1 to 4 do
   begin
    if i = mojeCislo then continue;
    if nTah < POCET_TAHOV div 4 then continue;

    if fEnemy[i] < fEnemy[mojeCislo] div 2 then
      UtocAZnicHo(jednotky, pocetJednotiek, i);
   end;}

   for i:=1 to pocetJednotiek do
   begin
     if jednotky[i].vlastnik = mojeCislo then
       if jednotky[i].prikaz = stoj then
       begin
         if typyJednotiek[jednotky[i].typ].kapacita > 0 then
         begin
           if nSpice > 0 then
             zniLocal(jednotky,mapa, i)
           {  jednotky[i].prikaz := zni}
           else
           begin
             jednotky[i].prikaz := chod;
             jednotky[i].tx := statX;
             jednotky[i].ty := (statY+velkostMapy div 2) div 2;
           end;
         end;
         if IsUtocnik(jednotky[i].typ) then
         begin
           inc(PairCount);
           if nUtocnik > 8 then
           begin
             if (PairCount mod 2) = 0 then
             begin
               jednotky[i].prikaz := chod;
               jednotky[i].tx := (2*(velkostMapy div 2) + 5*statX) div 7;
               jednotky[i].ty := (3*(velkostMapy div 2) + statY) div 4;
             end
             else
             begin
               jednotky[i].prikaz := chod;
               jednotky[i].tx := (3*(velkostMapy div 2) + statX) div 4;
               jednotky[i].ty := (2*(velkostMapy div 2) + 5*statY) div 7;
             end;
           end
           else begin
             jednotky[i].prikaz := chod;
             jednotky[i].tx := (velkostMapy div 2 + statX) div 2;
             jednotky[i].ty := (velkostMapy div 2 + statY) div 2;
           end;
         end;
       end;
   end;


end;




procedure tahaj(var jednotky:typeJednotky;
   pocetJednotiek:word; mapa:typeMapa; peniaze:longint);
var
  iLaunch,i:integer;
begin
  if JurkoActive then tahajJurko(jednotky, pocetJednotiek, mapa, peniaze)
  else tahajTinko(jednotky, pocetJednotiek, mapa, peniaze);

  if not isenemy then
 begin
    iLaunch := 0;
    for i:= 1 to pocetJednotiek do begin
      if jednotky[i].typ  = launcher then begin
        inc(iLaunch);
        if iLaunch < MAX_POZICIA then
        begin
          jednotky[i].prikaz := chod;
          jednotky[i].tx := PozicieX[iLaunch];
          jednotky[i].ty := PozicieY[iLaunch]-6;
        end
        else
        begin
          jednotky[i].prikaz := chod;
          jednotky[i].tx := 3;
          jednotky[i].ty := (nTah+3*i) mod 32;
        end;
      end;
    end;
  end;
end;

BEGIN
  nPartii := 0;
END.