Unit dat_typy;

interface

const POCET_HRACOV = 5;
      POCET_AKTIVNYCH_HRACOV = 4;
      POCET_TAHOV  = 1000;
      POCET_KORENIA = 300;

const velkostMapy = 32;

const korenie = -32000;
type typePolicko = integer;
{0 - prazdne policko, inak id jednotky
zaporne - korenie a id jednotky
korenie - iba korenie (nie jednotka)}
type typeMapa = array[1..velkostMapy,1..velkostMapy] of typePolicko;

type typeTypJednotky = record
       typeName      :string; {meno typu jednotky}
       speed         :byte; {ci a ako rychlo sa vie dana jednotka hybat}
       atackStrength :byte; {udernost strely}
       atackDistance :byte; {vzdialenost doletu strely}
       defence       :byte; {zaciatocna velkost obrany}
       timeToBuild   :byte; {pocet tahov, kym sa jednotka vyrobi}
       costToBuild   :byte; {co stoji spravit danu jednotku}
       produce       :byte; {kolko zarobi dana jednotka za jednotku korenia}
       kapacita      :byte; {kolko jednotiek korenia sa zmesti}
     end;

const pocetRoznychJednotiek = 6;
type typePoleTypovJednotiek = array[1..pocetRoznychJednotiek] of typeTypJednotky;

const typyJednotiek:typePoleTypovJednotiek = (
(typeName:'Zakladna'; speed:0; atackStrength:0; atackDistance:0;
   defence:150; timeToBuild:30; costToBuild:25; produce:0; kapacita:0),
(typeName:'Tank'; speed:2; atackStrength:5; atackDistance:2;
   defence:35; timeToBuild:15; costToBuild:50; produce:0; kapacita:0),
(typeName:'Kombajn'; speed:1; atackStrength:0; atackDistance:0;
   defence:65; timeToBuild:20; costToBuild:30; produce:40; kapacita:3),
(typeName:'Veza'; speed:0; atackStrength:10; atackDistance:3;
   defence:75; timeToBuild:20; costToBuild:125; produce:0; kapacita:0),
(typeName:'Vojak'; speed:1; atackStrength:3; atackDistance:2;
   defence:10; timeToBuild:10; costToBuild:15; produce:20; kapacita:1),
(typeName:'Launcher'; speed:2; atackStrength:10; atackDistance:4;
   defence:20; timeToBuild:20; costToBuild:80; produce:0; kapacita:0)
);
const zakladna = 1;
      tank     = 2;
      kombajn  = 3;
      veza     = 4;
      vojak    = 5;
      launcher = 6;

type typePrikaz = (stoj, chod, utoc, bran, nasleduj, zni, postav);
{ stoj - nic nerobi
  chod - pohybuje sa na dane miesto
  utoc - utoci na danu jednotku
  bran - obranuje danu jednotku tym, ze utoci na utocnika na tuto jednotku
  nasleduj - robi to, co dana jednotka
  zni - zacne zat najblizsie korenie
  postav - stavia na cielovom policku novu jednotku}

type typeJednotka = record
       x,y     :byte; {pozicia na mape}
       vlastnik:byte; {komu patri dana jednotka}
       typ     :byte; {akeho typu je dana jednotka}
       stavba  :byte; {kolko tahov sa uz stavia}
       shields :byte; {kolko ma este "zivotov"}
       korenie :byte; {kolko nazbierala jednotka korenia}
       tx, ty  :byte; {kam smeruje dana jednotka}
       idCiela :integer; {na koho utoci | brani | nasleduje dana jednotka}
       prikaz  :typePrikaz; {prikaz - co robi dana jednotka}
     end;

const maxPocetJednotiek = velkostMapy*velkostMapy;
type typeJednotky = array[1..maxPocetJednotiek] of typeJednotka;

function vzd(x1,y1,x2,y2:byte):byte;

implementation

function vzd(x1,y1,x2,y2:byte):byte;
begin
   vzd := abs(integer(x1) - x2) + abs(integer(y1) - y2);
end;

end.