Unit Hrac1;

interface

   uses dat_typy;

   function inicializujSa(cisloHraca:byte):string;
   procedure tahaj(
      var jednotky:typeJednotky;
      pocetJednotiek:word;
      mapa:typeMapa;
      peniaze:longint
   );

implementation
   Const
     HARVESTER  = KOMBAJN;
      Home:Array[1..4,1..2] of Word =( (1,1),(1,velkostmapy),(velkostmapy,1),
                                    (VelkostMapy,velkostmapy));
      smx:Array[1..4] of Integer =(-1,0,  1, 0);
      smy:Array[1..4] of Integer =( 0,-1, 0, 1 );
      PCHArv=7;
      MXBJ=10;
      CObr=10;
      VZ= 6;
      PrJ:Array[1..MXBJ]  of Byte = ( Tank, Tank, Launcher, Harvester,
                                   Launcher, Harvester, Launcher,
                                   Launcher, Launcher, Launcher);

   var mojeCislo:byte;
       BJ,PTah:Integer;
       PObrana,PocL,PocHarv,  PocLaunch,   PocSh, PocTank, PocUtok,
       PocVeza,   PocZakl,   PocEnemy,   MovEnemy:LongInt;
       underAttack:Boolean;

Function SGN(X:Integer):Integer;
Begin
  If X>0 then SGN:=1 else
  If X<0 then SGN:=-1 else
   SGN:=0;
end;


function inicializujSa(cisloHraca:byte):string;
begin
   mojeCislo := cisloHraca;
   inicializujSa := 'HarKill';
   BJ:=0;
   Ptah:=0;
   PObrana:=0;
end;




procedure tahaj(var jednotky:typeJednotky;
   pocetJednotiek:word; mapa:typeMapa; peniaze:longint);
var i,j,K:word;
    minEnemyId, minEnemyDistance, vzdd:word;
    Pen:LongInt;

Procedure VolnyXY(X,Y:Word; var X1,Y1:Byte);
Var I:Integer;
Begin
  For I:=1 to 4 do Begin
    X1:=X+smx[i];  Y1:=Y+smy[i];
    If (X1>=1) and (X1<=VelkostMapy) and
       (Y1>=1) and (Y1<=VelkostMapy) and
       ( (Mapa[x1,y1] = 0) or (Mapa[x1,y1]=korenie) ) then
       Exit;
  end;
  x1:=VelkostMapy+1;
end;

{ =============== }

var utoky:array[-10..10,-10..10]of integer;

function vihr(x,y:integer):boolean;
begin
 if (x<1)or(x>velkostmapy)or(y<1)or(y>velkostmapy) then vihr:=false
  else vihr:=true;
end;

procedure GetUtoky(x,y:integer);

var k,i,j:integer;

begin
 for i:=-10 to 10 do
  for j:=-10 to 10 do utoky[i,j]:=0;

 for k:=1 to pocetjednotiek do
  if (jednotky[k].vlastnik<>mojecislo)
     and(typyjednotiek[jednotky[k].typ].atackstrength<>0) then
   for i:=-10 to 10 do
    for j:=-10 to 10 do
     if vihr(x+i,y+j) then
     if vzd(x+i,y+j,jednotky[k].x,jednotky[k].y)<=
         typyjednotiek[jednotky[k].typ].speed+
         typyjednotiek[jednotky[k].typ].atackdistance then
      utoky[i,j]:=utoky[i,j]+typyjednotiek[jednotky[k].typ].atackstrength;
end;

function min(a,b:integer):integer;
begin
 if a<b then min:=a else min:=b;
end;

procedure GetTarget(x,y,r,fp:integer;var corr,idc:integer);
var k:integer;
 sila:integer;

begin
 sila:=maxint;
 corr:=0;
 idc:=-1;
 for k:=1 to pocetjednotiek do
  if (jednotky[k].vlastnik<>mojecislo)and
     (vzd(jednotky[k].x,jednotky[k].y,x,y)<=r) then
      if sila>min(fp,jednotky[k].shields) then
       begin
        sila:=min(fp,jednotky[k].shields);
        idc:=k;
        if jednotky[k].shields<fp then corr:=typyjednotiek[jednotky[k].typ].atackstrength;
       end;
end;

Procedure Kill(cu:integer);
var i,j,k:integer;
     sp,corr,idc:integer;
    mi,mj:integer;
    act,max:real;
    midc:integer;

    pom:integer;

begin
 max:=-1e20;
 sp:=typyjednotiek[jednotky[cu].typ].speed;
 GetUtoky(jednotky[cu].x,jednotky[cu].y);
 for i:=-sp to sp do
  for j:=-(sp-abs(i)) to sp-abs(i) do
   begin
    if vihr(jednotky[cu].x+i,jednotky[cu].y+j)=false then continue;
    if (mapa[jednotky[cu].x+i,jednotky[cu].y+j]<>0)and
       (mapa[jednotky[cu].x+i,jednotky[cu].y+j]<>korenie) then continue;
    GetTarget(jednotky[cu].x+i,jednotky[cu].y+j,
              typyjednotiek[jednotky[cu].typ].atackdistance,
              typyjednotiek[jednotky[cu].typ].atackstrength,corr,idc);
    act:=-1.1*utoky[i,j];
    if idc<>-1 then act:=act+corr+typyjednotiek[jednotky[cu].typ].atackstrength;
    for k:=1 to pocetjednotiek do
     if jednotky[k].vlastnik<>mojecislo then
      begin
       pom:=vzd(jednotky[cu].x+i,jednotky[cu].y+j,jednotky[k].x,
                 jednotky[k].y);


       act:=act+round(45/pom*15/(jednotky[k].shields+1));
      end;

    if act>max then
     begin
      max:=act;
      midc:=idc;
      mi:=i;
      mj:=j;
     end;
   end;
 if midc=-1 then
  begin
   jednotky[cu].prikaz:=chod;
   jednotky[cu].tx:=jednotky[cu].x+mi;
   jednotky[cu].ty:=jednotky[cu].y+mj;
  end
 else
  begin
   jednotky[cu].prikaz:=utoc;
   jednotky[cu].tx:=jednotky[cu].x+mi;
   jednotky[cu].ty:=jednotky[cu].y+mj;
   jednotky[cu].idciela:=midc;
  end;
end;

Function InZone(X:Integer):Boolean;
Begin
  If Vzd(Home[MojeCislo,1],home[mojecislo,2],Jednotky[X].X,Jednotky[x].Y)<15
     then InZone:=True else InZone:=False;

end;

{ =============== }

begin
   J:=0;
   Inc(PTah);
   Pen:=Peniaze;

   PocL:=0;   PocHarv:=0;   PocLaunch:=0;   PocSh:=0;
   PocVeza:=0;   PocZakl:=0;   PocEnemy:=0;   MovEnemy:=0;
   PocTank:=0;
   For I:=1 to PocetJednotiek do  Begin
     If (Jednotky[i].vlastnik<>MojeCislo) and
        (Typyjednotiek[jednotky[i].typ].speed=0)
      then Inc(MovEnemy);
     If (Jednotky[i].vlastnik<>MojeCislo)
      then Inc(PocEnemy);
     If (Jednotky[i].vlastnik=MojeCislo) and (jednotky[i].typ=launcher)
          and  (Jednotky[i].stavba=Typyjednotiek[launcher].timetobuild)
      then Inc(PocLaunch)
     else If (Jednotky[i].vlastnik=MojeCislo) and (jednotky[i].typ=tank)
          and  (Jednotky[i].stavba=Typyjednotiek[Tank].timetobuild)
      then Inc(PocTank)
     else  If (Jednotky[i].vlastnik=MojeCislo) and (jednotky[i].typ=Harvester)
       then Inc(PocHarv)
     else  If (Jednotky[i].vlastnik=MojeCislo) and (jednotky[i].typ=Veza)
       then Inc(PocVeza)
     else If (Jednotky[i].vlastnik=MojeCislo) and (jednotky[i].typ=Zakladna)
       then Inc(PocZakl);
   end;

   PocUtok:=PocLaunch+PocTank;

   for i:=1 to pocetJednotiek do
   if (jednotky[i].vlastnik = mojeCislo) then
   With Jednotky[i] do Begin
      if (typyJednotiek[jednotky[i].typ].speed = 0) then
      begin {zakladna}
         jednotky[i].prikaz := postav;
         VolnyXY(x,y,tx,ty);
         IDCiela:=0;
         If Tx<Velkostmapy+1 then BEgin
           If ((tX in [1,velkostmapy]) or (tY in [1,VelkostMapy]))
             and (Pen>=TypyJednotiek[zakladna].costtobuild) and (PTah>300)
           then Begin
             IdCiela:=Zakladna;
             Pen:=Pen-TypyJednotiek[Zakladna].CostToBuild;
           end else
           If BJ<MXBJ then Begin
             IF (Pen>=TypyJednotiek[PrJ[BJ+1]].costtobuild) then Begin
               Inc(BJ);
               IdCiela:=PrJ[BJ];
               Pen:=Pen-TypyJednotiek[Prj[BJ]].CostToBuild;
             end;
           end else
           If (PocHArv< PCHarv) and (Pen>=TypyJednotiek[Harvester].CosttoBuild)
           then Begin
             IdCiela:=Harvester;
             Pen:=Pen-TypyJednotiek[Harvester].CosttoBuild;
           end else
           If (PObrana<CObr) and (Pen>=TypyJednotiek[Launcher].CosttoBuild)
           then BEgin
             IdCiela:=Launcher;
             Pen:=Pen-TypyJednotiek[Launcher].CosttoBuild;
           end else
           If (Pen>=TypyJednotiek[Launcher].CosttoBuild) then Begin
             IdCiela:=Launcher;
             Pen:=Pen-TypyJednotiek[Launcher].CosttoBuild;
           end;
         end;
      end else if (typyJednotiek[jednotky[i].typ].kapacita > 0) then
      begin {kombajn}
         jednotky[i].prikaz:=zni;

      end else With Jednotky[i] do begin {zbran}
        underAttack:=False;
        For K:=1 to PocetJednotiek Do With Jednotky[k] do Begin
          If (vlastnik<>MojeCislo) and  InZone(k) then  Begin
            underAttack:=True;
          end;
        end;
        K:=PocetJednotiek+1;
        Repeat Dec(K); until (Jednotky[k].Vlastnik<>MojeCislo) or (K<1);
        inc(J);
        If J<=CObr then Begin
          If UnderAttack then Kill(I) else With Jednotky[i] do Begin
            prikaz:=chod;
            TX:=Abs(longint(home[mojecislo ,1])+VZ*Sgn(longint(Jednotky[K].X)-longint(Home[mojeCislo,1])));
            TY:=Abs(longint(home[mojecislo ,2])+VZ*Sgn(longint(Jednotky[K].y)-longint(Home[mojeCislo,2])));
          end;
        end else Begin
          Kill(I);
        end;
      end;
   end;
end;



END.