Unit Hrac2;

interface

   uses dat_typy;

   function inicializujSa(cisloHraca:byte):string;
   procedure tahaj(
      var jednotky:typeJednotky;
      pocetJednotiek:word;
      mapa:typeMapa;
      peniaze:longint
   );

implementation
   type tpozicia=record
                x,y:integer;
                cislo:integer;
                active:boolean;
               end;

   const pL=4;
         pK=2;
         pZ=8;
         smery:array[1..4,1..2] of integer=((0,1),(1,0),(-1,0),(0,-1));
         max=100;

   var mojeCislo:byte;
       tah:longint;
       zakx,zaky:integer;
       zaksx,zaksy:integer;
       poz2,pozciary:integer;
       zdroj:array[1..max] of tpozicia;
       ciel:array[1..max] of tpozicia;
       nz,nc:integer;

function inicializujSa(cisloHraca:byte):string;
begin
  mojeCislo := cisloHraca;
  inicializujSa := 'Skup2';
  tah:=0;
  pozciary:=3;
  poz2:=3;
end;

procedure tahaj(var jednotky:typeJednotky;
   pocetJednotiek:word; mapa:typeMapa; peniaze:longint);
var nzakladni,nkombajn,nlaunch:integer;
    nkorenie:integer;

procedure PoctyJednotiek;
var i:integer;
begin
 nzakladni:=0;
 nkombajn:=0;
 nlaunch:=0;
 for i:=1 to pocetjednotiek do
  if jednotky[i].vlastnik=mojecislo then
   case jednotky[i].typ of
    zakladna:inc(nzakladni);
    kombajn:inc(nkombajn);
    launcher:inc(nlaunch);
   end;
end;

procedure SmerZakladni;
var i:integer;
begin
 i:=1;
 while(jednotky[i].vlastnik<>mojecislo) or (jednotky[i].typ<>zakladna) do inc(i);
 if jednotky[i].x<=2 then begin zakx:=1;zaksx:=1; end
                     else begin zakx:=velkostmapy;zaksx:=-1 end;
 if jednotky[i].y<=2 then begin zaky:=1;zaksy:=1; end
                     else begin zaky:=velkostmapy;zaksy:=-1 end;
end;

function skuspostavit(co:byte):boolean;
var i,j:integer;
    x,y:integer;
    x2,y2:integer;
begin
 if peniaze>=typyjednotiek[co].costtobuild then begin
  for i:=1 to pocetjednotiek do
   if (jednotky[i].vlastnik=mojecislo) and (jednotky[i].typ=zakladna) and
      (jednotky[i].prikaz=stoj) then begin
       x:=jednotky[i].x;
       y:=jednotky[i].y;
       for j:=1 to 4 do begin
        x2:=x+smery[j,1];
        y2:=y+smery[j,2];
        if ((co<>zakladna) and (x2>=2) and (x2<velkostmapy) and (y2>=2) and (y2<velkostmapy) and
           ((mapa[x2,y2]=0) or (mapa[x2,y2]=korenie)))
        or ((co=zakladna) and ((x2=zakx) and (y2>=1) and (y2<=velkostmapy)
            or (y2=zakx) and (x2>=1) and (x2<=velkostmapy)) and
           ((mapa[x2,y2]=0) or (mapa[x2,y2]=korenie)))
            then begin
            mapa[x2,y2]:=co;
            peniaze:=peniaze-typyjednotiek[co].costtobuild;
            jednotky[i].prikaz:=postav;
            jednotky[i].idCiela:=co;
            jednotky[i].tx:=x2;
            jednotky[i].ty:=y2;
            skuspostavit:=true;
            exit;
           end;
       end;
      end;
  end;
  skuspostavit:=false;
end;

procedure PostavJednotky;
var pomerl,pomerk,pomerz:real;
    vys:boolean;
    zvys:boolean;
begin
 zvys:=false;
 repeat
  pomerl:=nlaunch/pl;
  pomerk:=nkombajn/pk;
  pomerz:=(nzakladni-1)/pz;
  if zvys then pomerz:=1e10;
  if nlaunch>0 then if nkorenie/nlaunch<=8 then pomerk:=1e10;
  if (pomerz<=pomerk) and (pomerz<=pomerl) then begin {zakladne}
   vys:=skuspostavit(zakladna);
   if vys then inc(nzakladni);
   zvys:=true;
   vys:=true;
  end else if (pomerl<=pomerz) and (pomerl<=pomerk) then begin {launchers}
   vys:=skuspostavit(launcher);
   if vys then inc(nlaunch);
  end else begin
   vys:=skuspostavit(kombajn);
   if vys then inc(nkombajn);
  end;
 until vys=false;
end;

procedure VymazZakladne;
var i:integer;
begin
 for i:=1 to pocetjednotiek do
  if(jednotky[i].vlastnik=mojecislo) and (jednotky[i].typ=zakladna) then
   jednotky[i].prikaz:=stoj;
end;

procedure prikazKombajnom;
var i:integer;
begin
 for i:=1 to pocetjednotiek do
  if (jednotky[i].vlastnik=mojecislo) and (jednotky[i].typ=kombajn) then
    jednotky[i].prikaz:=zni;
end;

procedure VolneKorenie;
var i,j:integer;
begin
 nkorenie:=0;
 for i:=1 to velkostmapy do for j:=1 to velkostmapy do
  if(mapa[i,j]<0) then inc(nkorenie);
end;

procedure zistipozciary;
var i:integer;
begin
{ pozciary:=2;}
 pozciary:=poz2;
 for i:=1 to pocetjednotiek do
  if (jednotky[i].vlastnik=mojecislo) and (jednotky[i].typ=kombajn) then
   if (vzd(jednotky[i].x,jednotky[i].y,zakx,zaky)>pozciary) then
    pozciary:=vzd(jednotky[i].x,jednotky[i].y,zakx,zaky);
 poz2:=pozciary;
 if pozciary>Trunc((2/3)*VelkostMapy) then pozciary:=Trunc(2/3*VelkostMapy);
end;

procedure Ohrozujuce;
var i:integer;
begin
 nc:=0;
 for i:=1 to pocetjednotiek do
  if (jednotky[i].vlastnik<>mojecislo) and (nc<nlaunch) and
     (jednotky[i].typ<>veza) and
     (vzd(jednotky[i].x,jednotky[i].y,zakx,zaky)<pozciary+6) then begin
      inc(nc);
      ciel[nc].cislo:=i;
      ciel[nc].x:=jednotky[i].x;
      ciel[nc].y:=jednotky[i].y;
      ciel[nc].active:=true;
     end;
end;

procedure RozmiestniPoCiare;
var jednotka:real;
    i:integer;
begin
 if (nc<nlaunch) then begin
  jednotka:=pozciary/(nlaunch-nc);
  for i:=1 to nlaunch-nc do begin
   ciel[i+nc].cislo:=0;
   ciel[i+nc].x:=zakx+trunc(jednotka*(i)*zaksx);
   ciel[i+nc].y:=zaky+trunc(jednotka*(nlaunch-i)*zaksy);
   if (ciel[i+nc].x<1) then ciel[i+nc].x:=1;
   if (ciel[i+nc].y<1) then ciel[i+nc].y:=1;
   if (ciel[i+nc].x>VelkostMapy) then ciel[i+nc].x:=VelkostMapy;
   if (ciel[i+nc].y>VelkostMapy) then ciel[i+nc].y:=VelkostMapy;
   ciel[i+nc].active:=true;
  end;
  nc:=nlaunch;
 end;
end;

procedure NaseJednotky;
var i:integer;
begin
 nz:=0;
 for i:=1 to pocetjednotiek do
  if (jednotky[i].vlastnik=mojecislo) and (jednotky[i].typ=launcher)
     and (jednotky[i].stavba>=20) then begin {20=TTBuild}
   inc(nz);
   zdroj[nz].x:=jednotky[i].x;
   zdroj[nz].y:=jednotky[i].y;
   zdroj[nz].cislo:=i;
   zdroj[nz].active:=true;
  end;
 nlaunch:=nz;
end;

procedure Parovanie;
var minvzd,minvzdz,maxvzd,maxvzdz,maxvzdc:integer;
    i,j,k:integer;
    x,y:byte;
begin
 for i:=1 to nc do begin
  maxvzd:=-1;
  for j:=1 to nc do if (ciel[j].active) then begin
   minvzd:=3*VelkostMapy;
   x:=ciel[j].x;
   y:=ciel[j].y;
   for k:=1 to nz do if zdroj[k].active and (vzd(zdroj[k].x,zdroj[k].y,x,y)<minvzd) then begin
    minvzd:=vzd(zdroj[k].x,zdroj[k].y,x,y);
    minvzdz:=k;
   end;
   if maxvzd<minvzd then begin
    maxvzd:=minvzd;
    maxvzdz:=minvzdz;
    maxvzdc:=j;
   end;
  end;
  zdroj[maxvzdz].active:=false;
  ciel[maxvzdc].active:=false;
  if ciel[maxvzdc].cislo=0 then begin {move}
   jednotky[zdroj[maxvzdz].cislo].prikaz:=chod;
   jednotky[zdroj[maxvzdz].cislo].tx:=ciel[maxvzdc].x;
   jednotky[zdroj[maxvzdz].cislo].ty:=ciel[maxvzdc].y;
  end else begin {attack}
   jednotky[zdroj[maxvzdz].cislo].prikaz:=utoc;
   jednotky[zdroj[maxvzdz].cislo].idciela:=ciel[maxvzdc].cislo;
  end;
 end;
end;

procedure NaNajblizsich;
var i,j:integer;
    minenemyid,minenemydistance,vzdd:integer;
begin
 for i:=1 to pocetjednotiek do
  if (jednotky[i].vlastnik=mojecislo) and (jednotky[i].typ=launcher) then
  begin
         jednotky[i].prikaz := utoc;
         minEnemyId := 0;
         minEnemyDistance := 1000;
         for j:=1 to pocetJednotiek do
         begin
            if (jednotky[j].vlastnik <> mojeCislo) then
            begin
               vzdd := vzd(jednotky[i].x, jednotky[i].y,
                  jednotky[j].x, jednotky[j].y);
               if (vzdd < minEnemyDistance) then
               begin
                  minEnemyDistance := vzdd;
                  minEnemyId := j;
               end;
            end;
         end;
         if (minEnemyId > 0) then
         begin
            jednotky[i].idCiela := minEnemyId;
         end else if jednotky[i].prikaz<>chod then begin
            jednotky[i].prikaz:=chod;
            jednotky[i].tx:=random(VelkostMapy)+1;
            jednotky[i].ty:=random(VelkostMapy)+1;
         end;
      end;

end;

procedure prikazLauncherom;
var i:integer;
    minenemyid,minenemydistance,j,vzdd:integer;
begin
 ZistiPozCiary;
 NaseJednotky;
 Ohrozujuce;
 if poz2>1.5*pozciary then NaNajblizsich else begin
  RozmiestniPoCiare;
  Parovanie;
 end;
end;

begin
 inc(tah);if tah=1 then SmerZakladni;
 VymazZakladne;
 PoctyJednotiek;
 VolneKorenie;
 PostavJednotky;
 PrikazKombajnom;
 PrikazLauncherom;
end;

END.