{$DEFINE EG} {EGA: ak pracujes s EGA monitorom a kartou}
{$DEFINE IMG} {IMG: ak chces zobrazovat obrazky jednotiek}

{

             P PPPPP                    bbb
             P     P                   b b
             P     P                  b  b
             P     P                  b b              jj
             P    P  r                b b              jj
             PPPPP   rrrr     oooo    bb      oooo
             P       r   r   o  o o   b  b   o  o o    jj
             P       r   r  o    o obbb  bbbo    o o  jjj
             P      r    r  o     oo  b  b  o     oojj  j
             P           r ro     o   bb b  o     o    jjjjj
             P            r  ooooo     bb    ooooo    j j
                                                     j  j
                                                     jjj


            ------------------------------------------------
}

Program Proboj_KSP_97_jesen;

uses graph, {grafika}
     crt, {crt}
     dat_typy, {datove typy}
     hrac1, hrac2, hrac3, hrac4, hrac5;

const arbiterFarba = 15;
{      RAND_SEED = 7777;}

type typeHrac = record
        inicializujSa:function(cisloHraca:byte):string;
        tahaj:procedure(var jednotky:typeJednotky;
           pocetJednotiek:word; mapa:typeMapa; peniaze:longint);
        peniaze:longint;
        id:byte; {identifikacne cislo hraca 1..POCET_HRACOV}
        farba:byte; {farba hraca}
        farba2:byte; {farba tmavsia, ale rovnaka}
        skoncil:longint; {cislo tahu, kedy skoncil}
        meno:string;
     end;

var poradie:array[1..POCET_AKTIVNYCH_HRACOV] of byte; {poradie tahov hracov}
    por:integer; {pomocna premenna pre poradie}
    tah:integer; {premenna cisla tahu}
    hra:integer;

    fout:text;
    celkoveSkore:array[1..POCET_HRACOV] of longint; { sucty bodov }

    mapa:typeMapa; {hlavna mapa}
    jednotky:typeJednotky; {vsetky jednotky}
    hracJednotky:typeJednotky; {jednotky pre proceduru tahHraca}
    pocetJednotiek:integer; {celkovy pocet jednotiek}
    existujeKorenie:boolean; {ci sa na mape este nachadza korenie}
    existujeVobecKorenie:boolean;

    hrac:array[1..POCET_HRACOV] of typeHrac;

    c:char;
    pauza:integer;

{$I grafika}

{ci vie na policko vstupit jednotka}
function volne(x,y:byte):boolean;
begin
   if ((x >= 1) and (x <= velkostMapy) and
      (y >= 1) and (y <= velkostMapy)) then
   begin
      if ((mapa[x,y] = 0) or (mapa[x,y] = korenie)) then volne:=true
      else volne:=false;
   end else volne:=false;
end;

{umiestni jednotku na policko (moze na nom uz byt korenie)}
procedure umiestni(x,y:byte;i:integer);
begin
   if (mapa[x,y] < 0) then
   begin
      if (i > 0) then mapa[x,y] := -i
      else mapa[x,y] := korenie; {umiestnuje nulu na zaporne}
   end else mapa[x,y] := i;
end;

function je_pozemna_jednotka(id:integer; c:byte):boolean;
begin
   if (id = korenie) then je_pozemna_jednotka := false
   else if (id = 0) then je_pozemna_jednotka := false
   else begin
      id := abs(id);
      je_pozemna_jednotka := (typyJednotiek[jednotky[id].typ].speed = 0);
   end;
end;

{vrati, ci na danom policku je ciste korenie (nie pod jednotkou)}
function je_tam_korenie(x, y:integer):boolean;
begin
   if ((x >= 1) and (x <= velkostMapy) and
      (y >= 1) and (y <= velkostMapy)) then
   begin
      je_tam_korenie := (mapa[x,y] = korenie);
   end else je_tam_korenie := false;
end;

{najde najblizsie korenie pri bode x,y}
procedure najdi_korenie(x, y:integer; var outx, outy:integer);
var nasiel:boolean;
    i,j:integer;
    ri,r:integer;
begin
   nasiel := false;
   if (existujeKorenie) then
   begin
      i := x; j := y-1;
      r := 1; {"polomer"}
      while ((not nasiel) and (r <= 2*velkostMapy)) do
      begin
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); inc(i); inc(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); dec(i); inc(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); dec(i); dec(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         ri := 1; while ((not nasiel) and (ri <= r)) do begin
            inc(ri); inc(i); dec(j);
            if je_tam_korenie(i,j) then nasiel := true;
         end;
         if (not nasiel) then begin dec(j); inc(r); end; {dalsi "kruh"}
      end;
      if (r > 2*velkostMapy) then existujeKorenie := false;
   end;
   if (nasiel) then
   begin
      outx := i; outy := j;
   end else begin
      outx := x; outy := y; {sorry, no korenie found}
   end;
end;

procedure postavJednotku(vlastnik:byte; typ:byte; x,y:byte);
begin
   if (volne(x,y)) then
   begin
      inc(pocetJednotiek);
      jednotky[pocetJednotiek].x := x;
      jednotky[pocetJednotiek].y := y;
      if (typyJednotiek[typ].speed = 0) then mapa[x,y] := pocetJednotiek
      else umiestni(x,y,pocetJednotiek);
      jednotky[pocetJednotiek].vlastnik := vlastnik;
      jednotky[pocetJednotiek].typ := typ;
      jednotky[pocetJednotiek].stavba := 0; {este sa nic nepostavilo}
      jednotky[pocetJednotiek].shields := typyJednotiek[typ].defence;
      jednotky[pocetJednotiek].korenie := 0;
      jednotky[pocetJednotiek].tx := x; {smeruje na svoje miesto}
      jednotky[pocetJednotiek].ty := y;
      jednotky[pocetJednotiek].idCiela := 0;
      jednotky[pocetJednotiek].prikaz := stoj;
   end; {inak bolo uz obsadene miesto mapy}
end;

procedure vystrel(nakoho:word; silou:byte);
begin
   if (jednotky[nakoho].shields > silou) then
   begin
      dec(jednotky[nakoho].shields, silou);
      dec(hracJednotky[nakoho].shields, silou);
   end else begin {TEMP}
      jednotky[nakoho].shields := 0; {uz vystrielane vsetko}
      jednotky[nakoho].vlastnik := 0;
      hracJednotky[nakoho].shields := 0; {uz vystrielane vsetko}
      hracJednotky[nakoho].vlastnik := 0;
      umiestni(jednotky[nakoho].x, jednotky[nakoho].y, 0);
   end;
   kresliPolicko(jednotky[nakoho].x, jednotky[nakoho].y);
end;

procedure initProboj;
var i,j:byte;
    w:integer;
begin
   pocetJednotiek := 0;
   for w:=1 to maxPocetJednotiek do jednotky[w].vlastnik := 0;
   for i:=1 to POCET_AKTIVNYCH_HRACOV do
   begin
      hrac[i].peniaze := 0;
      hrac[i].id := poradie[i];
      case (poradie[i]) of
         1: begin
               hrac[i].inicializujSa := hrac1.inicializujSa;
               hrac[i].tahaj         := hrac1.tahaj;
               hrac[i].farba         := 13;
               hrac[i].farba2        := 5;
            end;
         2: begin
               hrac[i].inicializujSa := hrac2.inicializujSa;
               hrac[i].tahaj         := hrac2.tahaj;
               hrac[i].farba         := 12;
               hrac[i].farba2        := 4;
            end;
         3: begin
               hrac[i].inicializujSa := hrac3.inicializujSa;
               hrac[i].tahaj         := hrac3.tahaj;
               hrac[i].farba         := 10;
               hrac[i].farba2        := 2;
            end;
         4: begin
               hrac[i].inicializujSa := hrac4.inicializujSa;
               hrac[i].tahaj         := hrac4.tahaj;
               hrac[i].farba         := 9;
               hrac[i].farba2        := 1;
            end;
         5: begin
               hrac[i].inicializujSa := hrac5.inicializujSa;
               hrac[i].tahaj         := hrac5.tahaj;
               hrac[i].farba         := 14;
               hrac[i].farba2        := 6;
            end;
      end;
      hrac[i].meno := hrac[i].inicializujSa(i);
      hrac[i].skoncil := 0; {este neskoncil}
      vypisBody(i);
   end;
   for i:=1 to velkostMapy do
      for j:=1 to velkostMapy do
         mapa[i,j] := 0;
{   randseed := RAND_SEED;}
{   Randomize;}
   {vygeneruj zaciatocnu poziciu}
   postavJednotku(1, zakladna, 1,1); postavJednotku(1, zakladna, 1,2);
   postavJednotku(1, zakladna, 2,1); postavJednotku(1, zakladna, 2,2);
   postavJednotku(2, zakladna, 1,velkostMapy);
   postavJednotku(2, zakladna, 1,velkostMapy-1);
   postavJednotku(2, zakladna, 2,velkostMapy);
   postavJednotku(2, zakladna, 2,velkostMapy-1);
   postavJednotku(3, zakladna, velkostMapy,1);
   postavJednotku(3, zakladna, velkostMapy,2);
   postavJednotku(3, zakladna, velkostMapy-1,1);
   postavJednotku(3, zakladna, velkostMapy-1,2);
   postavJednotku(4, zakladna, velkostMapy,velkostMapy);
   postavJednotku(4, zakladna, velkostMapy,velkostMapy-1);
   postavJednotku(4, zakladna, velkostMapy-1,velkostMapy);
   postavJednotku(4, zakladna, velkostMapy-1,velkostMapy-1);

   postavJednotku(1, kombajn, 4,4);
   postavJednotku(2, kombajn, 4,velkostMapy-3);
   postavJednotku(3, kombajn, velkostMapy-3,4);
   postavJednotku(4, kombajn, velkostMapy-3,velkostMapy-3);

   for w:=1 to POCET_KORENIA do
   begin
      repeat
         i:=random(velkostMapy)+1; j:=random(velkostMapy)+1;
      until mapa[i,j] = 0;
      mapa[i,j] := korenie;
   end;
   existujeKorenie := true;
   existujeVobecKorenie := true;
end;

function spocitajCeny(cislo:byte):longint;
var cena:longint;
    i:word;
begin
   cena := 0;
   for i := 1 to pocetJednotiek do
   if (jednotky[i].vlastnik = cislo) then cena := cena+
      typyJednotiek[jednotky[i].typ].costToBuild;
   spocitajCeny := cena;
end;


procedure tahHraca(cislo:byte);
var tempJednotky:typeJednotky;
    i,j, ciel, korenieX, korenieY:integer;
    tah:shortint;
    rozX, rozY:integer;
    dostrel:byte;
    maxEnemyStrength, minZakladVzd:integer;
    maxEnemyId, minZakladId, ch:integer;
    ok:boolean;
    count:integer;
begin

   existujeVobecKorenie := false;
   for i:=1 to velkostMapy do
      for j:=1 to velkostMapy do
         if (mapa[i,j] < 0) then existujeVobecKorenie:=true;

   existujeKorenie := existujeVobecKorenie;

   for i:=1 to pocetJednotiek do
   begin
      tempJednotky[i] := jednotky[i];
   end;

   hrac[cislo].tahaj(tempJednotky, pocetJednotiek, mapa, hrac[cislo].peniaze);

   {hracJednotky := tempJednotky;}
   for i:=1 to pocetJednotiek do
   begin
      hracJednotky[i] := jednotky[i];
      if ((jednotky[i].vlastnik = cislo) and
         (jednotky[i].stavba = typyJednotiek[jednotky[i].typ].timeToBuild)) then
      begin
         hracJednotky[i] := jednotky[i];
         hracJednotky[i].tx      := tempJednotky[i].tx;
         jednotky[i].tx          := tempJednotky[i].tx;
         hracJednotky[i].ty      := tempJednotky[i].ty;
         jednotky[i].ty          := tempJednotky[i].ty;
         hracJednotky[i].idCiela := tempJednotky[i].idCiela;
         jednotky[i].idCiela     := tempJednotky[i].idCiela;
         hracJednotky[i].prikaz  := tempJednotky[i].prikaz;
         jednotky[i].prikaz      := tempJednotky[i].prikaz;
         if (hracJednotky[i].tx = 0) then inc(hracJednotky[i].tx);
         if (hracJednotky[i].tx > velkostMapy) then
            hracJednotky[i].tx := velkostMapy;
         if (hracJednotky[i].ty = 0) then inc(hracJednotky[i].ty);
         if (hracJednotky[i].ty > velkostMapy) then
            hracJednotky[i].ty := velkostMapy;
         if ((hracJednotky[i].prikaz = postav)) then
         begin
            if ((hracJednotky[i].idCiela > pocetRoznychJednotiek) or
               (hracJednotky[i].idCiela <= 0)) then hracJednotky[i].idCiela := 1;
         end else begin
           if ((hracJednotky[i].idCiela > pocetJednotiek) or
               (hracJednotky[i].idCiela <= 0)) then
           begin
              hracJednotky[i].idCiela := 0;
              case hracJednotky[i].prikaz of
                 bran, utoc, nasleduj: hracJednotky[i].prikaz := stoj;
              end;
           end;

         end;
      end else begin
         hracJednotky[i].vlastnik := 0;
      end;
   end;

   {cyklus pre 'nasleduj'}
   for i:=1 to pocetJednotiek do
   if (hracJednotky[i].vlastnik = cislo) then
   begin
      if (hracJednotky[i].prikaz = nasleduj) then
      begin
         ciel := hracJednotky[i].idCiela;
         if (hracJednotky[ciel].prikaz = nasleduj) then {riziko zacyklenia}
         begin
            hracJednotky[i].vlastnik := 0;
         end else begin {korektne nasledovanie commandera}
            hracJednotky[i].tx      := hracJednotky[ciel].tx;
            hracJednotky[i].ty      := hracJednotky[ciel].ty;
            hracJednotky[i].idCiela := hracJednotky[ciel].idCiela;
            hracJednotky[i].prikaz  := hracJednotky[ciel].prikaz;
         end;
      end;
   end;

   {cyklus pre 'bran'}
   for i:=1 to pocetJednotiek do
   if (hracJednotky[i].vlastnik = cislo) then
   begin
      if (hracJednotky[i].prikaz = bran) then
      begin
         ch:=hracJednotky[i].idCiela; {CHranenec}
         maxEnemyId := 0;
         maxEnemyStrength := -1;
         for j:=1 to pocetJednotiek do
         begin {ak vie dana jednotka ohrozit v dalsom tahu CH}
            if ((jednotky[j].vlastnik <> cislo) and
               (vzd(hracJednotky[ch].x, hracJednotky[ch].y,
               jednotky[j].x, jednotky[j].y) <=
               (typyJednotiek[jednotky[j].typ].atackDistance+
               typyJednotiek[jednotky[j].typ].speed))) then
            begin
               if (typyJednotiek[jednotky[j].typ].atackStrength >
                  maxEnemyStrength) then
               begin
                  maxEnemyStrength :=
                     typyJednotiek[jednotky[j].typ].atackStrength;
                  maxEnemyId := j;
               end;
            end;
         end;
         if (maxEnemyId > 0) then
         begin
            hracJednotky[i].prikaz := utoc;
            hracJednotky[i].idCiela := maxEnemyId;
         end else begin
            hracJednotky[i].prikaz := chod; {chod ku chranencovi}
            hracJednotky[i].tx      := hracJednotky[ch].x;
            hracJednotky[i].ty      := hracJednotky[ch].y;
         end;
      end;
   end;

   {cyklus pre zatvu korenia}
   for i:=1 to pocetJednotiek do
   if ((hracJednotky[i].vlastnik = cislo) and
      (typyJednotiek[hracJednotky[i].typ].kapacita > 0)) then
   begin

      if (hracJednotky[i].prikaz = zni) then
      begin
         hracJednotky[i].prikaz := chod;
         najdi_korenie(hracJednotky[i].x, hracJednotky[i].y, korenieX, korenieY);
         hracJednotky[i].tx := korenieX;
         hracJednotky[i].ty := korenieY;
      end;

      if (mapa[hracJednotky[i].x, hracJednotky[i].y] < 0) then
      begin
         if (jednotky[i].korenie <
            typyJednotiek[hracJednotky[i].typ].kapacita) then
         begin
            inc(jednotky[i].korenie);
            mapa[hracJednotky[i].x, hracJednotky[i].y] := i; {kladne}
         end;
      end;
      if ((jednotky[i].korenie = typyJednotiek[hracJednotky[i].typ].kapacita)
         or ((not existujeVobecKorenie) and (jednotky[i].korenie > 0)) ) then
      begin {uz je plny harvester}
         minZakladId := 0;
         minZakladVzd := 1000;
         for j:=1 to pocetJednotiek do
         begin
            if ((jednotky[j].vlastnik = cislo) and
            (vzd(hracJednotky[i].x, hracJednotky[i].y,
            jednotky[j].x, jednotky[j].y) < minZakladVzd) and
            (typyJednotiek[jednotky[j].typ].speed = 0)) then
            begin
               minZakladId := j;
               minZakladVzd:= vzd(hracJednotky[i].x, hracJednotky[i].y,
                  jednotky[j].x, jednotky[j].y);
            end;
         end;
         if (minZakladId > 0) then
         begin
            hracJednotky[i].tx := jednotky[minZakladId].x;
            hracJednotky[i].ty := jednotky[minZakladId].y;
            hracJednotky[i].prikaz := chod;
         end else begin
            hracJednotky[i].prikaz := stoj;
         end;
      end;
   end;

   {cyklus pre 'utoc', 'chod' a 'stoj'}
   for i:=1 to pocetJednotiek do
   if (hracJednotky[i].vlastnik = cislo) then
   begin
      case (hracJednotky[i].prikaz) of
      utoc: begin {TEMP}
               if (hracJednotky[i].idCiela > 0) then
               begin
                  hracJednotky[i].tx := jednotky[hracJednotky[i].idCiela].x;
                  hracJednotky[i].ty := jednotky[hracJednotky[i].idCiela].y;
               end else begin
                  hracJednotky[i].tx := hracJednotky[i].x;
                  hracJednotky[i].ty := hracJednotky[i].y;
               end;
            end;
      chod, postav, zni: begin {nic, uz je tam target}
                    end;
      else begin {aj 'stoj'}
              hracJednotky[i].tx := hracJednotky[i].x;
              hracJednotky[i].ty := hracJednotky[i].y;
           end;
      end;
   end;



   {cyklus pre pohyb}
   for i:=1 to pocetJednotiek do
   if (hracJednotky[i].vlastnik = cislo) then
   begin
      if (typyJednotiek[hracJednotky[i].typ].speed > 0) then
      if ((hracJednotky[i].x <> hracJednotky[i].tx) or
         (hracJednotky[i].y <> hracJednotky[i].ty)) then
      begin {iba ak sa vie hybat, a nie je na destinacii}
         umiestni(hracJednotky[i].x, hracJednotky[i].y, 0);
         kresliPolicko(hracJednotky[i].x, hracJednotky[i].y);
         for tah:=typyJednotiek[hracJednotky[i].typ].speed downto 1 do
         if ((hracJednotky[i].prikaz <> utoc) or
            (vzd(hracJednotky[i].x, hracJednotky[i].y,
            hracJednotky[i].tx, hracJednotky[i].ty) >
            typyJednotiek[hracJednotky[i].typ].atackDistance)) then
         begin
            rozX := integer(hracJednotky[i].tx) - hracJednotky[i].x;
            rozY := integer(hracJednotky[i].ty) - hracJednotky[i].y;
            ok:=false;
            if (abs(rozX) > abs(rozY)) then
            begin
               if ((rozX > 0) and
                  (volne(hracJednotky[i].x+1, hracJednotky[i].y))) then
                  begin inc(hracJednotky[i].x); ok:=true; end
               else
               if ((rozX < 0) and
                  (volne(hracJednotky[i].x-1, hracJednotky[i].y))) then
                  begin dec(hracJednotky[i].x); ok:=true; end;
            end;
            if (not ok) then begin {x nespravil krok}
               if ((rozY > 0) and
                  (volne(hracJednotky[i].x, hracJednotky[i].y+1))) then
                  begin inc(hracJednotky[i].y); ok:=true; end
               else
               if ((rozY < 0) and
                  (volne(hracJednotky[i].x, hracJednotky[i].y-1))) then
                  begin dec(hracJednotky[i].y); ok:=true; end;
            end;
            if ((not ok) and (abs(rozX) <= abs(rozY))) then
            begin {y nespravil prvy krok}
               if ((rozX > 0) and
                  (volne(hracJednotky[i].x+1, hracJednotky[i].y))) then
                  begin inc(hracJednotky[i].x); ok:=true; end
               else
               if ((rozX < 0) and
                  (volne(hracJednotky[i].x-1, hracJednotky[i].y))) then
                  begin dec(hracJednotky[i].x); ok:=true; end;
            end;
            if (not ok) then
            begin {veruze krok sa spravit nepodarilo ziadnym smerom}
               korenieX := hracJednotky[i].x;
               korenieY := hracJednotky[i].y;
               count := ord(volne(korenieX-1,korenieY)) +
                  ord(volne(korenieX+1,korenieY)) +
                  ord(volne(korenieX,korenieY-1)) +
                  ord(volne(korenieX,korenieY+1));
               count := random(count+1);
               if (volne(korenieX-1,korenieY)) then
               if (count = 0) then dec(hracJednotky[i].x)
               else else inc(count); dec(count);
               if (volne(korenieX+1,korenieY)) then
               if (count = 0) then inc(hracJednotky[i].x)
               else else inc(count); dec(count);
               if (volne(korenieX,korenieY-1)) then
               if (count = 0) then dec(hracJednotky[i].y)
               else else inc(count); dec(count);
               if (volne(korenieX,korenieY+1)) then
               if (count = 0) then inc(hracJednotky[i].y)
               else else inc(count); dec(count);
               {ak sa to dostalo bez pohybu az sem, pravdepodobnost je 1/(p.m.)}
            end;
         end;
         umiestni(hracJednotky[i].x, hracJednotky[i].y, i);
         kresliPolicko(hracJednotky[i].x, hracJednotky[i].y);
         jednotky[i].x := hracJednotky[i].x;
         jednotky[i].y := hracJednotky[i].y;
      end;
   end;

   {cyklus pre strelbu}
   for i:=1 to pocetJednotiek do
   if (hracJednotky[i].vlastnik = cislo) then
   begin

      dostrel := typyJednotiek[hracJednotky[i].typ].atackDistance;
      if (dostrel > 0) and (hracJednotky[i].idCiela > 0) then
      if ((hracJednotky[hracJednotky[i].idCiela].shields > 0) and
         (vzd(hracJednotky[hracJednotky[i].idCiela].x,
              hracJednotky[hracJednotky[i].idCiela].y,
              hracJednotky[i].x, hracJednotky[i].y) <= dostrel) and
         (hracJednotky[hracJednotky[i].idCiela].vlastnik <> cislo)) then
      begin {striela sa na existujuci ciel, ktory je na dosah}
         vystrel(hracJednotky[i].idCiela,
            typyJednotiek[hracJednotky[i].typ].atackStrength);
         dostrel:=0;
      end;
      if (dostrel > 0) then {teraz uz ako boolean (0 or hodnota)}
      begin
         maxEnemyId := 0;
         maxEnemyStrength := -1;
         for j:=1 to pocetJednotiek do
         begin
            if ((jednotky[j].vlastnik <> cislo) and
               (vzd(hracJednotky[i].x, hracJednotky[i].y,
               jednotky[j].x, jednotky[j].y) <= dostrel)) then
            begin
               if (typyJednotiek[jednotky[j].typ].atackStrength >
                  maxEnemyStrength) then
               begin
                  maxEnemyStrength :=
                     typyJednotiek[jednotky[j].typ].atackStrength;
                  maxEnemyId := j;
               end;
            end;
         end;
         if (maxEnemyId > 0) then
         begin
            vystrel(maxEnemyId,
               typyJednotiek[hracJednotky[i].typ].atackStrength);
         end;
      end;
   end;

   {cyklus pre 'postav'}
   i:=1;
   while (i <= pocetJednotiek) do
   begin
      if ((hracJednotky[i].vlastnik = cislo) and
         (typyJednotiek[hracJednotky[i].typ].speed = 0)) then
      begin
         if (hracJednotky[i].prikaz = postav) then
         begin
            if (vzd(hracJednotky[i].tx, hracJednotky[i].ty,
               hracJednotky[i].x, hracJednotky[i].y) = 1) then
            if (volne(hracJednotky[i].tx, hracJednotky[i].ty)) then
            if (hrac[cislo].peniaze >=
               typyJednotiek[hracJednotky[i].idCiela].costToBuild)
            then begin
               postavJednotku(cislo, hracJednotky[i].idCiela, {idCiela ako typ}
                  hracJednotky[i].tx, hracJednotky[i].ty);
               kresliPolicko(hracJednotky[i].tx, hracJednotky[i].ty);
               dec(hrac[cislo].peniaze,
                  typyJednotiek[hracJednotky[i].idCiela].costToBuild);
            end; {inak sa stavia prilis daleko, alebo cez cosi, alebo nie su $}
         end;
      end;
      inc(i);
   end;


   { !!! update zniceneho - velmi dolezita cast !!! }
   {v tempJednotky[i].x,y mam povodny ciel jednotky[i]}
   for i:=1 to pocetJednotiek do
   begin
      if ((jednotky[i].idCiela > 0) and (jednotky[i].idCiela <= pocetJednotiek))
      then begin
         tempJednotky[i].x := jednotky[jednotky[i].idCiela].x;
         tempJednotky[i].y := jednotky[jednotky[i].idCiela].y;
      end else begin
         tempJednotky[i].x := 0;
      end;
   end;
   i:=1; j:=1;
   while (j <= pocetJednotiek) do
   begin
      while ((j <= pocetJednotiek) and (jednotky[j].vlastnik = 0)) do
      begin
         inc(j);
      end;
      if (j <= pocetJednotiek) then
      begin
         if (j > i) then
         begin
            umiestni(jednotky[j].x,jednotky[j].y,i);
            jednotky[i]:=jednotky[j];
            tempJednotky[i].x:=tempJednotky[j].x;
            tempJednotky[i].y:=tempJednotky[j].y;
         end;
         inc(i);
         inc(j);
      end;
   end;
   pocetJednotiek := i-1; {tam to az doslo}
   {tak a teraz doporiadku indexy, ktore sa mohli zmenit pri stratach}
   for i:=1 to pocetJednotiek do
   begin
      if (tempJednotky[i].x > 0) then begin
         jednotky[i].idCiela := mapa[
            tempJednotky[i].x, tempJednotky[i].y];
         if (jednotky[i].idCiela = korenie) then
            jednotky[i].idCiela := 0
         else jednotky[i].idCiela := abs(jednotky[i].idCiela);
      end else jednotky[i].idCiela := 0;
   end;


   {cyklus pre update stavieb a pripocitavanie penazi z korenia}
   for i:=1 to pocetJednotiek do
   if (jednotky[i].vlastnik = cislo) then
   begin
      if (jednotky[i].stavba < typyJednotiek[jednotky[i].typ].timeToBuild) then
      begin
         inc(jednotky[i].stavba);
         kresliPolicko(jednotky[i].x, jednotky[i].y);
      end;
      {ak je korenie > 0, pridaj peniaze}
      if (jednotky[i].korenie > 0) then
      begin
         {iba ak sme pri zakladni}
         ok:=false;
         if (jednotky[i].x > 1) then begin
            minZakladId := mapa[jednotky[i].x-1, jednotky[i].y];
            if je_pozemna_jednotka(minZakladId, cislo) then ok:=true;
         end;
         if (jednotky[i].y > 1) then begin
            minZakladId := mapa[jednotky[i].x, jednotky[i].y-1];
            if je_pozemna_jednotka(minZakladId, cislo) then ok:=true;
         end;
         if (jednotky[i].x < velkostMapy) then begin
            minZakladId := mapa[jednotky[i].x+1, jednotky[i].y];
            if je_pozemna_jednotka(minZakladId, cislo) then ok:=true;
         end;
         if (jednotky[i].y < velkostMapy) then begin
            minZakladId := mapa[jednotky[i].x, jednotky[i].y+1];
            if je_pozemna_jednotka(minZakladId, cislo) then ok:=true;
         end;
         if (ok) then
         begin
            inc(hrac[cislo].peniaze,
               typyJednotiek[jednotky[i].typ].produce*jednotky[i].korenie);
            jednotky[i].korenie:=0;
         end;
      end;
   end;

end;

procedure pocitajJednotky(ii:byte);
var i:word;
begin
   i:=1;
   while ((i<=pocetJednotiek) and (jednotky[i].vlastnik <> ii)) do
   begin
      inc(i);
   end;
   if (i > pocetJednotiek) then
   begin
      hrac[ii].skoncil := tah;
   end;
end;


begin {main}
   randomize;

   initGrafika(POCET_AKTIVNYCH_HRACOV);

   for hra:=1 to POCET_HRACOV do celkoveSkore[hra]:=0;

   hra:=1;
   assign(fout,'body.txt');
   rewrite(fout);
   writeln(fout, 'Vystupny subor pre archivaciu priebezneho stavu');
   close(fout);

   c:=' ';

   while ((c <> #27) and (hra <= 10)) do
      { 1 hra - debug&development alebo 4 hry - naostro}
   begin {pre rozne poradia}

      {vzdy len jedna z permutacii, kde kazdy zacina inde ako minule}
{
      case hra of
       1: begin
           poradie[1]:=1;
           poradie[2]:=2;
           poradie[3]:=3;
           poradie[4]:=4;
          end;
       2: begin
           poradie[1]:=3;
           poradie[2]:=4;
           poradie[3]:=1;
           poradie[4]:=2;
          end;
       3: begin
           poradie[1]:=2;
           poradie[2]:=1;
           poradie[3]:=4;
           poradie[4]:=3;
          end;
       4: begin
           poradie[1]:=4;
           poradie[2]:=3;
           poradie[3]:=2;
           poradie[4]:=1;
          end;
      end;
}
      case hra of
       1: begin poradie[1]:=1; poradie[2]:=2; poradie[3]:=3; poradie[4]:=4; end;
       2: begin poradie[1]:=2; poradie[2]:=3; poradie[3]:=4; poradie[4]:=5; end;
       3: begin poradie[1]:=3; poradie[2]:=4; poradie[3]:=5; poradie[4]:=1; end;
       4: begin poradie[1]:=4; poradie[2]:=5; poradie[3]:=1; poradie[4]:=2; end;
       5: begin poradie[1]:=5; poradie[2]:=1; poradie[3]:=2; poradie[4]:=3; end;
       6: begin poradie[1]:=1; poradie[2]:=3; poradie[3]:=5; poradie[4]:=2; end;
       7: begin poradie[1]:=3; poradie[2]:=5; poradie[3]:=2; poradie[4]:=4; end;
       8: begin poradie[1]:=5; poradie[2]:=2; poradie[3]:=4; poradie[4]:=1; end;
       9: begin poradie[1]:=2; poradie[2]:=4; poradie[3]:=1; poradie[4]:=3; end;
      10: begin poradie[1]:=4; poradie[2]:=1; poradie[3]:=3; poradie[4]:=5; end;
      end;
      initProboj;
      kresliIhrisko;
      vypisMena;

      c:=' '; pauza:=0;

      tah:=1;
      while (tah <= POCET_TAHOV) do
      begin

         vypisTahy(tah);
         for por:=1 to POCET_AKTIVNYCH_HRACOV do
         begin
            if (hrac[por].skoncil = 0) then
            begin
               tahHraca(por);
               pocitajJednotky(por);
               vypisBody(por);
            end;
         end;

         if (pauza > 0) then delay(pauza);
         if keypressed then c := readkey;
         case c of
            'p','P': c:=readkey;
            'q','Q': tah:=POCET_TAHOV;
            #27: tah:=POCET_TAHOV;
            '+': if (pauza > 10) then dec(pauza,10);
            '-': if (pauza < 10000) then inc(pauza,10);
         end;
         inc(tah);
      end;

      dec(tah);
      vypisTahy(tah);

      for por:=1 to POCET_AKTIVNYCH_HRACOV do
      begin
         hrac[por].skoncil := hrac[por].peniaze + spocitajCeny(por);
         inc(celkoveSkore[poradie[por]],hrac[por].skoncil);
         hrac[por].peniaze := hrac[por].skoncil;
         vypisBody(por);
      end;

      assign(fout,'body.txt');
      append(fout);
      writeln(fout, 'Po ', hra, ' hre:');
      for por:=1 to POCET_AKTIVNYCH_HRACOV do
      begin
         writeln(fout,'   Hrac ', hrac[por].meno
            , ' ma: ', hrac[por].skoncil, ' spolu: ', celkoveSkore[poradie[por]]);
      end;
      close(fout);

      while keypressed do if (readkey = ' ') then;
      if (readkey = ' ') then;

      inc(hra);
   end; {pre rozne poradia}

   closeGrafika;

   for por:=1 to 11 do WriteLn;
   TextColor(14);
   WriteLn('              -=-==-==[۱۲]==-==-=-               ');
   TextColor(15);
   WriteLn('              Proboj jesennho sstredenia KSP 27oct-2nov 1997               ');
   TextColor(14);
   WriteLn('              -=-==-==[۱۲]==-==-=-               ');
   TextColor(7);
   WriteLn;

end. {main}
